#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
lora01.py

20160604
"""

import sys
from PyQt4 import Qt, QtGui, QtCore
from ui_lora import Ui_LoraGUI
import serial
from time import sleep
from crc16b import calcByte,calcString,hexCRC,checkModbusWithCrc,readHex

class LoraGUI(QtGui.QWidget, Ui_LoraGUI):
	def __init__(self, parent=None, f=QtCore.Qt.WindowFlags()):
		QtGui.QWidget.__init__(self, parent, f)
		self.setupUi(self)
		
		if len( sys.argv ) == 2 :
			szPort = sys.argv[1]
			nBauds = 9600
		else :
			if len( sys.argv ) == 3 :
				szPort = sys.argv[1]
				nBauds = int(sys.argv[2])
			else :
				szPort = "/dev/ttyUSB0"
				nBauds = 9600

		port = szPort
		baudrate = nBauds
		
		try: 	
			self.ser = serial.Serial(
				port,
				baudrate,
				timeout=0,
				parity=serial.PARITY_NONE,
				stopbits=serial.STOPBITS_TWO,
				bytesize=serial.EIGHTBITS
			)
		except serial.SerialException as e:
			print szPort, " port is not connected"
			self.close()
			sys.exit(-1)
		szTitle = "%s @%d" % (port,baudrate)	
		self.setWindowTitle(szTitle)
		self.connect(self.lineEditStr, Qt.SIGNAL("textChanged(QString)"), self.funcStr2Hex)
		
	def funcStr2Hex(self,szStr):
		st = ""
		for ch in str(szStr):
			#nSt = int(str(ch),16)
			st += "%02X" % ord(ch)
			
		self.lineEditHex.setText(st)
	
	def __del__(self):
		self.ser.close()

if __name__ == '__main__':

	app = QtGui.QApplication(sys.argv)
	window = LoraGUI()
	window.show()

	sys.exit(app.exec_())
